;--------------------------------------------------------------------------------
;	vY}NX^[CI IG-B20 ԍډvO v2.1
;	dx@\
;	dX^[g@\
;	ߕd~@\
;	tB^N[jOʒm@\
;	^C}[@\
;
;	Programmed by GRANADA, Since 2009/08/18`
;	v0.0: ԍڒxdvOx[Xɉ
;	v1.0: 2009/08/19		12F675 ver, tB^N[jOo@\ǉ
;	v1.1: 2009/08/20		12F683 ֈڐA
;	v2.0: 2009/08/21-26		펞dڑiJEg_E^C}[jΉAHύX
;	v2.1: 2010/10/18		dAŉߕdh~~悤dlύX
;
;	12V -> ACC or IG2           ڑ		ԘAB^C}[
;	12V -> BAT                  ڑ		24ԉғB^C}[
;	12V -> BAT & ( ACC or IG2 ) Mڑ	ԘA{^C}[L
;
;	{vO̓^u4ɐݒ肷Yɐ`܂
;	LFhttp://www.asahi-net.or.jp/~SE1M-NITU/html/IG-B20.htm
;--------------------------------------------------------------------------------

	LIST		P=12F683
	INCLUDE		P12F683.INC
	ERRORLEVEL	-205
	ERRORLEVEL	-302

CB  = _CPD_OFF
CB &= _CP_OFF
CB &= _BOD_ON
CB &= _MCLRE_OFF
CB &= _PWRTE_ON
CB &= _WDT_OFF
CB &= _INTRC_OSC_NOCLKOUT

	__CONFIG	CB
	__IDLOCS	H'0100'

;--------------------------------------------------------------------------------
;	ϐAhX`
;--------------------------------------------------------------------------------

CBLOCK			 H'20'		; ϐGA擪AhX

	VOLTAGE					; obedXgAp

	DELAY_COUNTER			; xJE^
	DISCH_COUNTER			; ߕdopJE^
	BAT_ST_COUNTER			; obe[d񕜊ĎpJE^

	SEC_COUNTER				; bJE^
	MIN_COUNTER				; JE^

	MINUTE					; c莞ԁij

ENDC

CBLOCK			 H'70'		; ϐGA擪AhX
							; 12F683 ̏ꍇ 70H`7FH  Bank0,1 ʗ̈
							; 荞݂ł͂ǂ̃y[WփANZXɔł邩킩Ȃ̂
							; ޔp̕ϐ͔Ôߋʗ̈ɊmۂĂ

	W_WORK					; 荞ݎ W WX^ޔp
	ST_WORK					; 荞ݎ̃Xe[^XWX^ޔp

	COUNTER1				; ԑ҂p[N
	COUNTER2				;       V
	COUNTER3				;       V

	USER_FLAG				; etO

ENDC

;--------------------------------------------------------------------------------
;	萔`iDEFINE ̕ EQU fobOɕ֗j
;--------------------------------------------------------------------------------

;			= 1/4.0, Vref+ = 5V, Vref- = GND Ńobed𑪒肵ꍇA
#DEFINE		ALART_V			D'145'		; 11.4V  8bit A/D ϊl = 11.4/4.0 * 255/5
#DEFINE		RESTORE_V		D'166'		; 13.0V  8bit A/D ϊl = 13.0/4.0 * 255/5
#DEFINE		CLEANING_V		D'193'		;  3.8V  8bit A/D ϊl =      3.8 * 255/5

#DEFINE		BAT_ST_MARGIN	D'5'		; obe[d񕜊ĎJE^  2b x   5 = 10b
#DEFINE		DELAY_SEC		D'100'		; dx					0.1b x 100 = 10b
#DEFINE		DISCH_MARGIN	D'50'		; ߕdo				0.1b x  50 =  5b
#DEFINE		TIMER_MIN		D'240'		; ^C}[쎞ԁij

#DEFINE		BATTERY			0			; obedo
#DEFINE		IG_B20_CTRL		1			; IG-B20 XCb`
#DEFINE		BUZZER			2			; duU[
#DEFINE		ACC				3			; ACC o
#DEFINE		FILTER			4			; tB^[N[jOoAH=A3V =N[jO
#DEFINE		IG_B20_POWER	5			; IG-B20 d

#DEFINE		TIMER_FLAG		USER_FLAG,0	; ^C}[tOAH=^C}쒆
#DEFINE		TIMER_ENABLE	USER_FLAG,1	; ^C}[[hL
#DEFINE		ACC_ON_FLAG		USER_FLAG,2	; H = 莞 ACC ON ɂȂ

;--------------------------------------------------------------------------------
;	|[g`
;--------------------------------------------------------------------------------

#DEFINE		POWER_PORT		GPIO,IG_B20_POWER	; d|[g`
#DEFINE		CTRL_PORT		GPIO,IG_B20_CTRL	; XCb`|[g`
#DEFINE		FILTER_PORT		GPIO,FILTER			; tB^[Mo|[g`
#DEFINE		ACC_PORT		GPIO,ACC			; ACC o|[g`
#DEFINE		BUZZER_PORT		GPIO,BUZZER			; ߕdx|[g`

;--------------------------------------------------------------------------------
;	vO擪
;--------------------------------------------------------------------------------

	ORG		H'0'
	GOTO	INITIALIZE

;--------------------------------------------------------------------------------
;	荞ݏ
;--------------------------------------------------------------------------------

	ORG		H'4'			; 荞ݏ擪AhX

	MOVWF	W_WORK			; WX^Ҕ
	SWAPF	STATUS,W		; Z tOeȂ悤AMOVF ł͂Ȃ SWAPF gp
	MOVWF	ST_WORK

;--------------------------------------------------------------------------------
;	ACC ԃ`FbN
;--------------------------------------------------------------------------------

	BTFSS	ACC_PORT		; H = ACC OFF, L = ACC ON
	GOTO	RESET_TMR		; ACC ON Ȃ̂Ń^C}ƂɂZbg

	BSF		TIMER_FLAG		; ACC OFF Ȃ̂łЂƂ܂^C}tO𗧂Ă

	GOTO	MODE_CHECK		; ^C}p

RESET_TMR:

	BCF		TIMER_FLAG		; ^C}[tOZbg
	BSF		TIMER_ENABLE	; ACC ̒ʓdmFł̂Ń^C}@\͗L[hɃZbg

	CALL	SET_MINUTE		; ^C}c莞ԂZbg
	CALL	CLEAR_EVENT		; 荞݃JE^

	GOTO	POP_REG			; 荞ݏI

;--------------------------------------------------------------------------------
;	샂[h`FbN
;--------------------------------------------------------------------------------

MODE_CHECK:

	BTFSS	TIMER_ENABLE	; ^C}L`FbN
	GOTO	POP_REG			; ^C}iACC [hjȂ̂ŉȂŖ߂

;--------------------------------------------------------------------------------
;	݂̃^C}ғԃ`FbN
;--------------------------------------------------------------------------------

	BTFSS	TIMER_FLAG		; ^C}tO`FbN, H = ^C}쒆
	GOTO	POP_REG			; ^C}~Ȃ̂ŉȂŖ߂

;--------------------------------------------------------------------------------
;	b̔
;--------------------------------------------------------------------------------

	DECFSZ	SEC_COUNTER,F	; JE^`FbN
	GOTO	POP_REG			; 1b̂Ȃ̂ŉȂŖ߂

	CALL	RESET_SEC_COUNTER	; bJE^̃Zbg

;--------------------------------------------------------------------------------
;	̔
;--------------------------------------------------------------------------------

	DECFSZ	MIN_COUNTER,F	; JE^`FbN
	GOTO	POP_REG			; ꕪȂ犄荞ݏI

;--------------------------------------------------------------------------------
;	1̏
;--------------------------------------------------------------------------------

	CALL	CLEAR_EVENT		; JE^

	MOVF	MINUTE,F		; Ôߎc莞ԃ`FbN
	BTFSC	STATUS,Z		; c莞Ԃ͂łɃ[?
	GOTO	POP_REG			; Ƀ[̂ŉȂŖ߂

;--------------------------------------------------------------------------------
;	c莞ԃJEg_E
;--------------------------------------------------------------------------------

	DECF	MINUTE,F		; c莞ԃJEg_E

;--------------------------------------------------------------------------------
;	荞ݕA
;--------------------------------------------------------------------------------

POP_REG:					; WX^A`荞ݏI

	CALL	SET_TMR0		; TMR0 WX^Đݒ

	SWAPF	ST_WORK,W
	MOVWF	STATUS
	SWAPF	W_WORK,F
	SWAPF	W_WORK,W

	BCF		INTCON,T0IF		; TMR0荞݃tONAĂ
	RETFIE					; 荞ݏI

;--------------------------------------------------------------------------------
;	WX^
;--------------------------------------------------------------------------------

INITIALIZE:

	BANKSEL	GPIO			; Bank 0
	CLRF	GPIO			; S|[g L 
	CALL	POWER_OFF		; ЂƂ܂df

	BANKSEL	OSCCON
	MOVLW	B'01110000'		; Bank 1, NbN 8MHz
	MOVWF	OSCCON			; gݒ

	CLRF	OSCTUNE			; Bank 1, NbN

	CLRF	TRISIO			; Bank 1AЂƂ܂S|[go͂Ɏw
	NOP
	BSF		TRISIO,BATTERY	; obedo|[g͂ɐݒ
	NOP
	BSF		TRISIO,FILTER	; tB^[N[jOMo|[g͂ɐݒ
	NOP
	BSF		TRISIO,ACC		; ACC o|[g͂ɐݒ

	MOVLW	B'00110000'		; A/D ϊNbN -> FRCAS|[gfW^w
	MOVWF	ANSEL			; Bank 1
	NOP
	BSF		ANSEL,BATTERY	; obedo|[gAiO
	NOP
	BSF		ANSEL,3			; tB^N[jOdo|[g AN3 (GPIO4) AiO

	BANKSEL	CMCON0			; Bank 0
	MOVLW	B'00000111'		; Rp[^gpAݒ肵Ȃ Port 0 ̋
	MOVWF	CMCON0

	MOVLW	B'00000001'		; lA REFAAD Ro[^d ONAAN0  A/D ϊ
	MOVWF	ADCON0			; Bank 0

;--------------------------------------------------------------------------------
;	TMR0 ݒ, 8ms 荞ݔݒ
;--------------------------------------------------------------------------------

	BANKSEL	OPTION_REG		; Bank 1

	MOVLW	B'10000101'		; Weak pull up disable, TMR0 interanal clock, PSA = TMR0, PS = 1:64
	MOVWF	OPTION_REG

	BANKSEL	INTCON			; Bank 0
	BSF		INTCON,T0IE		; TMR0I[o[t[荞ݔ
	NOP
	BSF		INTCON,GIE		; 荞݋

;--------------------------------------------------------------------------------
;	ϐ
;--------------------------------------------------------------------------------

START0:

	CALL	SET_TMR0		; TMR0 WX^AJEgJn

	CALL	INIT_DISCH_COUNTER	; ߕdopJE^

	CALL	SET_MINUTE		; ^C}Zbg
	CALL	CLEAR_EVENT		; JE^

	CLRF	USER_FLAG		; StONA

;--------------------------------------------------------------------------------
;	d ON ܂ł̃fBC
;--------------------------------------------------------------------------------

START:

	MOVLW	DELAY_SEC
	MOVWF	DELAY_COUNTER	; dxԐݒ

DELAY1:

	CALL	CHECK_BATTERY	; obedĎ

	BTFSS	TIMER_ENABLE	; ^C}L[h
	GOTO	DELAY2			; ^C}Ȃ̂ ACC ̓`FbNȂ

	CALL	CHECK_ACC		; ACC ̏Ԃ`FbN
	BTFSS	ACC_ON_FLAG
	GOTO	WAIT_ACC_ON		; ^C}L ACC  OFF ɂȂĂ̂ ēx ACC ON ҂

DELAY2:

	DECFSZ	DELAY_COUNTER,F
	GOTO	DELAY1			; 񐔃[vB100ms x ݒ

;--------------------------------------------------------------------------------
;	IG-B20 Jn
;--------------------------------------------------------------------------------

EXEC_POWER_ON:

	CALL	POWER_ON		; dJn

	CALL	BEEP			; uU[炷
	CALL	WAIT_100ms
	CALL	BEEP			; uU[炷

	BSF		CTRL_PORT		; XCb`  ʎ
	CALL	WAIT_500ms
	BCF		CTRL_PORT

	CALL	WAIT_500ms		; ҂

	BSF		CTRL_PORT		; ēxXCb`  ʋ
	CALL	WAIT_500ms
	BCF		CTRL_PORT

;--------------------------------------------------------------------------------
;	C[v
;--------------------------------------------------------------------------------

MAIN1:

	BTFSS	TIMER_ENABLE	; ^C}@\L[h ?
	GOTO	MAIN2			; ^C}@\Ȃ̂Ń^C}֘A̓XLbv

	BTFSS	TIMER_FLAG		; ^C}ԃ`FbN
	GOTO	MAIN2			; ^C}~Ȃ̂Ŏc莞ԃ`FbN͂Ȃ

CHECK_MINUTE:

	MOVF	MINUTE,F		; c莞ԃ`FbNBJEg_Ê͊荞ݏŎs
	BTFSC	STATUS,Z
	GOTO	TIMER_END		; c莞ԃ[Ȃ̂ ACC ҂

MAIN2:

	CALL	CHECK_BATTERY	; obedĎ
	CALL	CHECK_FILTER	; tB^[N[jOM`FbN

	GOTO	MAIN1

;--------------------------------------------------------------------------------
;	^C}Ԍo߂ɂdf
;--------------------------------------------------------------------------------

TIMER_END:

	CALL	POWER_OFF		; dؒf

WAIT_ACC_ON:

	BCF		TIMER_FLAG		; ^C}[tONA

	CALL	CHECK_ACC		; ACC ԃ`FbN
	BTFSC	ACC_ON_FLAG		; H = ACC ON
	GOTO	RESTART			; ACC ON ɂȂ̂ŃX^[g

	CALL	CHECK_BATTERY	; obedĎ

	GOTO	WAIT_ACC_ON		; ACC `FbN

RESTART:

	GOTO	START			; ċN

;--------------------------------------------------------------------------------
;	ȉTu[`Q
;--------------------------------------------------------------------------------

;--------------------------------------------------------------------------------
;	obe[d`FbN`ߕdo
;--------------------------------------------------------------------------------

CHECK_BATTERY:

	MOVLW	B'00000001'		; AN0, l, A/D d ON
	MOVWF	ADCON0			; Bank 0

	CALL	WAIT_100ms		; v`[W˂

	CALL	READ_VOLTAGE	; obedĎ

	MOVF	VOLTAGE,W
	SUBLW	ALART_V			; ALART_V - BATTERY -> W
	BTFSS	STATUS,C		; if BATTERY <= ALART_V, C=1 -> skip next line
	RETURN					; obe͐Ȃ̂ŉȂŖ߂

	DECFSZ	DISCH_COUNTER,F
	RETURN					; 񐔂ɒBĂȂ̂ŃJEg_Ê݂Ė߂

;--------------------------------------------------------------------------------
;	ߕdȂ̂ IG-B20 d~`dAĎ`ċN
;--------------------------------------------------------------------------------

	CALL	POWER_OFF		; IG-B20 df

WAIT_RESET:

	CALL	INIT_ST_COUNTER	; dAĎpJE^

WAIT_RESET2:

	CALL	BEEP			; uU[炷
	CALL	WAIT_1sec
	CALL	WAIT_1sec

	CALL	READ_VOLTAGE	; obedĎ

	MOVF	VOLTAGE,W
	SUBLW	RESTORE_V		; RESTORE_V - BATTERY -> W
	BTFSC	STATUS,C		; if RESTORE_V <= BATTERY, C=0 -> skip next line
	GOTO	WAIT_RESET		; obe[ds

	DECFSZ	BAT_ST_COUNTER,F
	GOTO	WAIT_RESET2		; 񐔊Ďs

							; 񐔁iԁjd񕜂mF
	GOTO	START0			; ep[^[ďčċN

;--------------------------------------------------------------------------------
;	A/D ϊ
;--------------------------------------------------------------------------------

READ_VOLTAGE:

	BCF		PIR1,ADIF		; ADIF  0 ɁiA/D ϊĨrbg 1 ɂȂj
	BSF		ADCON0,GO		; GO (start) bit 𗧂Ă A/D ϊJn

EXEC_AD:

	BTFSC	ADCON0,GO		; A/D ϊI? 0 Ȃ玟XLbv
	GOTO	EXEC_AD			; ܂ϊ

	MOVF	ADRESH,W		; A/D ϊlǂݏo
	MOVWF	VOLTAGE			; ЂƂ܂ėpɕۑ

	RETURN

;--------------------------------------------------------------------------------
;	d
;--------------------------------------------------------------------------------

POWER_ON:

	BCF		POWER_PORT		; d   (L = FET ON)

	RETURN

POWER_OFF:

	BSF		POWER_PORT		; dؒf (H = FET OFF)
	BCF		TIMER_FLAG		; tONA

	RETURN

;--------------------------------------------------------------------------------
;	tB^[N[jOM`FbN
;--------------------------------------------------------------------------------

CHECK_FILTER:

	MOVLW	B'00001101'		; AN3, l, AD d ON
	MOVWF	ADCON0			; Bank 0

	CALL	WAIT_100ms		; v`[W˂

	CALL	READ_VOLTAGE	; tB^N[jOdĎ

	MOVF	VOLTAGE,W
	SUBLW	CLEANING_V		; CLEANING_V - PORT(W) -> W
	BTFSS	STATUS,C		; if PORT <= CLEANING_V, C=1 -> skip next line
	RETURN					; tB^[͐Ȃ̂ŉȂŖ߂

	CALL	BEEP
	CALL	WAIT_100ms
	CALL	BEEP
	CALL	WAIT_1sec

	RETURN

;--------------------------------------------------------------------------------
;	ACC o|[g`FbN
;--------------------------------------------------------------------------------

CHECK_ACC:

	BCF		ACC_ON_FLAG		; tONAĂ

	BTFSS	ACC_PORT		; ACC `FbN, L = ACC ON
	BSF		ACC_ON_FLAG		; ACC ON Ȃ̂ŃtO𗧂Ă

	RETURN

;--------------------------------------------------------------------------------
;	TMR0 JE^̃Zbg
;--------------------------------------------------------------------------------

SET_TMR0:
							; TMR0 ̓JEgAbv
	MOVLW	D'6'			; 255 - 250 + 1  250 JEgAbv
	MOVWF	TMR0			; 8MHz  0.5us x PS 64 x 250 counts = 8ms Ɋ荞ݔ

	RETURN

;--------------------------------------------------------------------------------
;	ԃJE^̏
;--------------------------------------------------------------------------------

CLEAR_EVENT:

	MOVLW	D'60'			; 1min = 60 sec
	MOVWF	MIN_COUNTER

RESET_SEC_COUNTER:

	MOVLW	D'125'			; 8ms ̊荞ݏ1bɂȂ邩
	MOVWF	SEC_COUNTER

	RETURN

;--------------------------------------------------------------------------------
;	ߕdo֘Ap[^[
;--------------------------------------------------------------------------------

INIT_DISCH_COUNTER:

	MOVLW	DISCH_MARGIN	; ߕdoԃZbg
	MOVWF	DISCH_COUNTER

	RETURN

INIT_ST_COUNTER:

	MOVLW	BAT_ST_MARGIN	; obe[d񕜃`FbNpp[^[
	MOVWF	BAT_ST_COUNTER

	RETURN

;--------------------------------------------------------------------------------
;	c莞Ԃ̏
;--------------------------------------------------------------------------------

SET_MINUTE:

	MOVLW	TIMER_MIN
	MOVWF	MINUTE			; c莞ԃZbg

	RETURN

;--------------------------------------------------------------------------------
;	uU[炷
;--------------------------------------------------------------------------------

BEEP:

	BSF		BUZZER_PORT		; uU[炷
	CALL	WAIT_100ms
	BCF		BUZZER_PORT

	RETURN

;--------------------------------------------------------------------------------
;	Cuǂݍ
;--------------------------------------------------------------------------------

	INCLUDE		Time.lib	; NbN8MHzpԑ҂[vCu

;--------------------------------------------------------------------------------
;	vOI
;--------------------------------------------------------------------------------

	END
